/*
* Copyright 2009(c) Theo Pavlidis
* See PixWin.h for a detailed notice on the use of the software
*/

// BlockCompDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BlockComp.h"
#include "BlockCompDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBlockCompDlg dialog




CBlockCompDlg::CBlockCompDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlockCompDlg::IDD, pParent)
	, m_K(4)
	, m_boxsize(20)
	, m_NColors(2)
	, m_UseIcons(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBlockCompDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_K, m_K);
	DDV_MinMaxInt(pDX, m_K, 2, 20);
	DDX_Text(pDX, IDC_EDIT_BX, m_boxsize);
	DDV_MinMaxInt(pDX, m_boxsize, 10, 100);
	DDX_Text(pDX, IDC_EDIT1, m_NColors);
	DDV_MinMaxInt(pDX, m_NColors, 2, 5);
	DDX_Check(pDX, IDC_CHECK_ICONS, m_UseIcons);
}

BEGIN_MESSAGE_MAP(CBlockCompDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RUN, &CBlockCompDlg::OnBnClickedRun)
	ON_BN_CLICKED(IDC_BUTTON_STATS, &CBlockCompDlg::OnBnClickedButtonStats)
END_MESSAGE_MAP()


// CBlockCompDlg message handlers

BOOL CBlockCompDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	UpdateData(FALSE);

	m_W.InitStats();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBlockCompDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBlockCompDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBlockCompDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CBlockCompDlg::OnBnClickedRun()
{
	// TODO: Add your control notification handler code here
	int old_K = m_K, old_Colors = m_NColors, old_Box = m_boxsize;
	BOOL old_Icons = m_UseIcons;
	if(UpdateData(TRUE)==FALSE) return;
	if(old_K != m_K || old_Colors != m_NColors || old_Box != m_boxsize || old_Icons != m_UseIcons) {
		::AfxMessageBox("Change in Parameters. Statistics will be re-initialized.\
\nClick OK to see the accumulated statistics.");
		m_W.QueryStats();
		m_W.InitStats();
	}
	CRect r;
	GetWindowRect(&r);
	int x0 = r.left, y0 = 0;
	m_W.PopWindow(x0, y0, m_K, m_NColors, m_boxsize, m_UseIcons);
}

void CBlockCompDlg::OnBnClickedButtonStats()
{
	m_W.QueryStats();
}
